// backColor :
// Shareware (see readme.txt for conditions and licence)
// Andrei Negoita
// ProfCont Expert, Bucharest Roumanie
// E-Mail : profcont@fx.ro
//==============================================
// Single function
// Function CalcBackColor(ColorPanel,ColorFont:TColor):TColor;
// calc Shadowcolor for reliefs controls
// work good in aprox 80 % combination panelcolor/fontcolor
// hlstorgb, rgbtohls is from Foley, via MS, transcription for Delphi by author.
unit backcolor;

interface

uses
  SysUtils, Windows, Classes, Graphics, StdCtrls;

Function CalcBackColor(ColorPanel,ColorFont:TColor):TColor;
implementation
Function min(a,b:word):Word;
begin
if a<b then min:=a else min:=b;
end;
Function max(a,b:word):Word;
begin
if a>=b then max:=a else max:=b;
end;
const RGBMAX=255;
      HLSMAX=240;
      UNDEFINED=HLSMAX*2/3;
Function RGBtoHLS(tlrgbcolor:tcolor):LongInt;
var lrgbcolor:LongInt;
R,G,B,cMax,cMin,Rdelta,Gdelta,Bdelta,l,s,h:word;
fl,fs,fh:double;
begin
{$R-}
lrgbcolor:=colortorgb(tlrgbcolor);
r:=GetRValue(lrgbcolor);
g:=GetGValue(lrgbcolor);
b:=GetBValue(lrgbcolor);
cmax:=max(max(r,g),b);
cmin:=min(min(r,g),b);
fl:=(((cmax+cmin)*HLSMAX)+rgbmax)/(2*rgbmax); L:=trunc(fl);
If cmax=cmin then
 begin
 s:=0; h:=trunc(undefined);

 end else
 begin
  If L<=(hlsmax div 2) then
   s:=trunc((((cmax-cmin)*hlsmax)+((cmax+cmin)/2))/(cmax+cmin)) else
   s:=trunc((((cmax-cmin)*hlsmax)+((2*rgbmax-cmax-cmin)/2))/(2*rgbmax-cmax-cmin));
   rdelta:=trunc((((cmax-r)*(hlsmax/6))+
        ((cmax-cmin)/2))/(cmax-cmin));
   gdelta:=trunc((((cmax-g)*(hlsmax/6))+
        ((cmax-cmin)/2))/(cmax-cmin));
   bdelta:=trunc((((cmax-b)*(hlsmax/6))+
        ((cmax-cmin)/2))/(cmax-cmin));
  if r=cmax then h:=bdelta-gdelta else
  if g=cmax then h:= (hlsmax div 3)+rdelta-bdelta else
  h:=((2*hlsmax) div 3)+Gdelta-rdelta;
  if h<0 then h:=h+hlsmax;
  if h>hlsmax then h:=h-hlsmax;

 end;
rgbtohls:=rgb(h,l,s);
{$R+}
end;
Function HueToRGB(n1,n2,hue:word):word;
var ret:word;
Begin
{$R-}
if hue<0 then  hue:=hue+hlsmax;
if hue>hlsmax then hue:=hue-hlsmax;
if hue<(hlsmax div 6) then
begin  huetorgb:=trunc((n1+(((n2-n1)*hue+(hlsmax div 12))/(hlsmax div 6))));
 exit;
end;
if hue<(hlsmax div 2) then begin huetorgb:=n2; exit; end;
if hue<((hlsmax*2) div 3) then
begin huetorgb:=trunc(n1+(((n2-n1)*(((hlsmax*2) div 3)-hue)+(hlsmax div 12))/(hlsmax div 6)));
 exit; end else begin huetorgb:=n1; exit; end;
{$R+}
end;
Function HLStoRGB(hue,lum,sat:word):LongInt;
var R,G,B,Magic1,Magic2:word;
begin
{$R-}
if sat=0 then
 begin r:=trunc((lum*rgbmax)/hlsmax); g:=r; b:=r;
 end else
 Begin
 if lum <= (hlsmax div 2) then
   magic2:=trunc((lum*(hlsmax+sat) + (hlsmax div 2))/hlsmax) else
   Magic2:=trunc(lum + sat - ((lum*sat)+(hlsmax div 2))/hlsmax);
   magic1:=2*lum-magic2;
   r:=trunc((huetorgb(magic1,magic2,hue+(hlsmax div 3)) * rgbmax +
        + (hlsmax div 2))/hlsmax);
   g:=trunc((huetorgb(magic1,magic2,hue)*rgbmax+(hlsmax div 2))/hlsmax);
   b:=trunc((huetorgb(magic1,magic2,hue-(hlsmax div 3))*rgbmax+
     + (hlsmax div 2))/hlsmax);
 end;
{$R+}
hlstorgb:=rgb(r,g,b);
end;

Function CalcBackColor(ColorPanel,ColorFont:TColor):TColor;
var HLSpanel,HLSFont:LongInt; LuminPanel,LuminFont,LuminBack:Word;
begin

{$R-}
HLSpanel:=RGBtoHLS(ColorPanel);
HLSFont:=RGBtoHLS(ColorFont);
LuminPanel:=GetGValue(HLSpanel); LuminFont:=GetGValue(HLSFont);

//=============== My GOLD CODE (Smile..) ==================
If (LuminFont<=LuminPanel) and (LuminFont<119) then
 begin
  LuminBack:=LuminPanel+(LuminPanel div 5); If LuminBack>=HLSMAX then
   LuminBack:=HLSMAX-1;
 end else
 begin
   LuminBack:= (Luminpanel div 4);
   If LuminBack<=0 then LuminBack:=1;
 end;
 CalcBackColor:=HLStoRGB(GetRValue(HLSPanel),LuminBack,GetBValue(HLSPanel));
 // ===============My GOLD CODE (Smile..) ===================
{$R+}
end;
end.
