// TReliefDBGrid :
// Shareware (see readme.txt for conditions and licence)
// Andrei Negoita
// ProfCont Expert, Bucharest Roumanie
// E-Mail : profcont@fx.ro
//==============================================
// 1. use "relief" tehnologie for cool DBGrid
// 2. use ColorAlternative for 2color dbgrid
// nothing important else (on mouse event for drag's op).
//===know problems:
// none known
// all relief control work with >=256 colors
// ========Is good for:
// - Replacement for dbgrid
//=========Aditional information : column color is preserved on odd row
unit ReliefDBGrid;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, Grids, DBGrids, BackColor;

type
  TReliefDBGrid = class(TDBGrid)
  private
    { Private declarations }
    FOnMouseDown: TMouseEvent;
    FColorAlternative: Tcolor;
    procedure WMVScroll(var Message: TWMVScroll);  message WM_VSCROLL;
  protected
    { Protected declarations }
    procedure KeyUp(var Key: Word; Shift: TShiftState); override;
    procedure KeyDown(var Key: Word; Shift: TShiftState); override;
    procedure MouseDown(Button: TMouseButton; Shift: TShiftState;
      X, Y: Integer); override;
    procedure DrawColumnCell(const Rect: TRect; DataCol: Integer;
    Column: TColumn; State: TGridDrawState); override;
    Function CalcNumber(const rect:Trect):Integer;
  published
    { Published declarations }
    //property Row;
    property ColorAlternative:Tcolor read FcolorAlternative write FcolorAlternative default clwindow;
    property OnMouseDown read FOnMouseDown write FOnMouseDown;
  end;

procedure Register;

implementation
Function TReliefDbgrid.CalcNumber(const rect:Trect):Integer;
begin
CalcNumber:=rect.top div (rect.bottom-rect.top);
end;
procedure TReliefDBGrid.DrawColumnCell(const Rect: TRect; DataCol: Integer;
    Column: TColumn; State: TGridDrawState);
var oldcolor,backcolor,locColor:tcolor;
k,oldk,ident:Integer;
begin
 if gdselected in state  then
 begin
 defaultdrawcolumncell(rect,datacol,column,state);
 exit;
 end;
If odd(calcNumber(rect)) then
LocColor:=column.color else LocColor:=ColorAlternative;
OldColor:=column.Font.Color;
canvas.brush.color:=LocColor;
Canvas.FillRect(Rect);
 backcolor:=CalcBackColor(LocColor,column.font.color);
 Canvas.Font.Color := backcolor;
 setbkmode(canvas.handle,Transparent);
case column.alignment of
taLeftJustify: begin k:=ta_left; ident:=rect.left+1; end;
taRightJustify: begin k:=ta_right; ident:=rect.right-1; end;
end;
 oldk:=settextAlign(canvas.handle,k);
 Canvas.Textout(ident, Rect.Top + 1,column.Field.DisplayText);
 Canvas.Font.Color := OldColor;
 // setbkmode(canvas.handle,Opaque);
 Canvas.TextOut( ident+1, Rect.Top + 2,column.Field.DisplayText);
 settextalign(canvas.handle,oldk);
end;

procedure TReliefDBGrid.MouseDown(Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if Assigned(FOnMouseDown) then
    FOnMouseDown(Self, Button, Shift, X, Y);
  inherited MouseDown(Button, Shift, X, Y);
end;
procedure TReliefDbGrid.WMVScroll(var Message: TWMVScroll);
begin
inherited;
If message.scrollcode=sb_endscroll then repaint;
end;

procedure TReliefDBGrid.KeyUp(var Key: Word; Shift: TShiftState);
Begin
Inherited;
If (key=vk_next) or (key=vk_prior) then repaint;
end;
procedure TReliefDBGrid.KeyDown(var Key: Word; Shift: TShiftState);
Begin
Inherited;
If (key=vk_up) or (key=vk_down)  then repaint;
end;
procedure Register;
begin
  RegisterComponents('Relief', [TReliefDBGrid]);
end;

end.

