// TReliefLabel :
// Shareware (see readme.txt for conditions and licence)
// Andrei Negoita
// ProfCont Expert, Bucharest Roumanie
// E-Mail : profcont@fx.ro
//==============================================
// 1. use "relief" tehnologie for cool Label
// nothing else
//===know problems:
// none
// all relief control work with >=256 colors
// ========Is good for:
// - Replacement for TLabel
unit ReliefLabel;


interface

uses
  SysUtils, Windows, Classes, Graphics, StdCtrls, BackColor;

type

  TReliefLabel = class(TLabel)
  private
    BackColor:TColor;

  protected
    procedure DoWriteText(var Rect: TRect; Flags: Word);
    procedure Paint; override;

  public
    constructor Create(AOwner: TComponent); override;
  published

  end;

procedure Register;

implementation

constructor TReliefLabel.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  backColor:=clwhite;
end;



procedure TReliefLabel.DoWriteText(var Rect: TRect; Flags: Word);
var
  R: TRect;
  OldColor:TColor;
begin
  //if not ShowAccelChar then Flags:=Flags or DT_NOPREFIX;
  if not Enabled then
  begin
  Canvas.Font.Color:=clGrayText;
  DrawText(Canvas.Handle, PChar(Caption), Length(Caption), Rect, Flags);
  exit;
  end;

  canvas.font:=font;
  oldColor:=Canvas.font.color;

  begin
    BackColor:=CalcBackColor(self.color,canvas.font.color);
    Canvas.Font.Color:=BackColor;
    R:=Rect;
    OffsetRect(R, -1, -1);
    DrawText(Canvas.Handle, PChar(Caption), Length(Caption), R, Flags);
    Canvas.Font.color:=oldcolor;
    R:=Rect;
    DrawText(Canvas.Handle, PChar(Caption), Length(Caption), R, Flags);
  end


end;

procedure TReliefLabel.Paint;
const
  Alignments: array[TAlignment] of Word=(DT_LEFT, DT_RIGHT, DT_CENTER);
var
  Rect: TRect;
begin
  with Canvas do
  begin
    if not Transparent then
    begin
      Brush.Color:=Self.Color;
      Brush.Style:=bsSolid;
      FillRect(ClientRect);
    end;
    Brush.Style:=bsClear;
    Rect:=ClientRect;
    DoWriteText(Rect, (DT_EXPANDTABS or DT_WORDBREAK) or Alignments[Alignment]);
  end;
end;

procedure Register;
begin
  RegisterComponents('Relief', [TReliefLabel]);
end;

end.
