// TReliefTreeView :
// Shareware (see readme.txt for conditions and licence)
// Andrei Negoita
// ProfCont Expert, Bucharest Roumanie
// E-Mail : profcont@fx.ro
//==============================================
// 1. use "relief" tehnologie for cool treeview
// 2. use ColorAlternative for root text (put ':' in text node and see)
// 3. Property (with) CheckBoxex
// nothing else
//===know problems:
// work only in runtime mode
// on win95, aparently need update commctrl (ie>=ie3?)
// don't use this control if you have somes 1000 nodes ! The speed is not very good.
// all relief control work with >=256 colors
// ========Is good for:
// - menu control (cool !)
// - information control (cool !) & table information control(fieldname=roottext)
// with litle modifications: replacement for groupcheckboxes, and editing string
// record from tables.

unit ReliefTreeView;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, backcolor;

type
  TReliefTreeView = class(TTreeView)
  private
  LocCanvas:TControlcanvas;
  BackColor,BackColorAlternative:Tcolor;
  FColorAlternative: Tcolor;
  fCheckBoxes : Boolean;
   function GetCheckBoxes:Boolean;
   procedure SetCheckBoxes(value:Boolean);
    { Private declarations }
  protected
  procedure Loaded; override;
  procedure PaintIt(var msg:TWMpaint); message WM_paint;
    { Protected declarations }
  public
  Constructor Create(AOwner:Tcomponent); override;
  Destructor destroy; override;
  procedure CreateParams(var Params: TCreateParams);override;
    { Public declarations }
  published
  property ColorAlternative:Tcolor read FcolorAlternative write FcolorAlternative default clwindow;
  property CheckBoxes : boolean read GetCheckBoxes write SetCheckBoxes;
    { Published declarations }
  end;

procedure Register;


implementation
procedure TReliefTreeView.CreateParams(var Params: TCreateParams);
const TVS_CHECKBOXES=$0100;
begin
  inherited CreateParams(Params);
  if fCheckBoxes then
  with Params do
    Style := Style or TVS_CHECKBOXES;
end;
function TReliefTreeview.GetCheckBoxes:Boolean;
begin
  result:=fCheckBoxes;
end;

procedure TReliefTreeview.SetCheckBoxes(value:Boolean);
begin
  if fCheckBoxes<>Value then begin
    fCheckBoxes:=Value;
    RecreateWnd;
  end;
end;

constructor TReliefTreeView.create(AOwner:Tcomponent);

begin
inherited;

end;
Destructor TReliefTreeView.destroy;
begin
inherited;
if loccanvas<>nil then LocCanvas.free;
end;
PROCEDURE TReliefTreeView.paintIt(var msg:twmpaint);
var i,k:Integer; lr:Trect;
dc:hdc; s1,s2:string;
//ps:TPaintStruct;
begin
PaintHandler(msg);
if csdesigning in componentstate then exit;
if loccanvas=nil then
begin
LocCanvas:=tControlcanvas.create;
LocCanvas.control:=self;
end;
dc:=msg.dc;
LocCanvas.Handle:=dc;
LocCanvas.brush.style:=bsclear;
try

for i:=0 to items.count-1 do
 begin
 if (items.item[i].selected=false) or (self.focused=false) then
 begin
 k:=pos(':',items.item[i].text);
 lr:=items.item[i].displayrect(true);
 //loccanvas.brush.color:=color;
 setbkmode(Loccanvas.handle,Transparent);
 locCanvas.FillRect(items.item[i].displayRect(true));
 if k=0 then
 Begin
 Loccanvas.font:=self.font;
 LocCanvas.font.color:=Backcolor;
 LocCanvas.Textout(lr.left+1,lr.top,items.item[i].text);

 LocCanvas.font.color:=self.font.color;
 LocCanvas.Textout(lr.left+2,lr.top+1,items.item[i].text);
 end else
 begin //k<>0 only for me..information control..
 s1:=copy(items.item[i].text,0,k+1);
 s2:=copy(items.item[i].text,k+1,length(items.item[i].text)-k);

 Loccanvas.font:=self.font;
 LocCanvas.font.color:=BackcolorAlternative;
 LocCanvas.Textout(lr.left+1,lr.top,s1);
 LocCanvas.font.color:=self.colorAlternative;
 LocCanvas.Textout(lr.left+2,lr.top+1,s1);

 k:=LocCanvas.textwidth(s1)-LocCanvas.textwidth(':'){3};
 LocCanvas.font.color:=Backcolor;
 LocCanvas.Textout(lr.left+1+k,lr.top,s2);
 LocCanvas.font.color:=self.Font.Color;
 LocCanvas.Textout(lr.left+2+k,lr.top+1,s2);


 end;
 end;
 end;
finally
LocCanvas.handle:=0;
end;
end;
procedure TReliefTreeView.Loaded;
var tv_first:word;
begin
inherited;
tv_first:=$1100;
backcolor:=calcBackColor(self.color,self.font.color);
BackColorAlternative:=calcBackColor(self.color,self.ColorAlternative);
sendmessage(self.handle,tv_first+29,0,lparam(self.color));
sendmessage(self.handle,tv_First+30,0,lparam(self.font.color));

end;
procedure Register;
begin
  RegisterComponents('Relief', [TReliefTreeView]);
end;

end.
